<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑分销商用户记录表' : '添加分销商用户记录表'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="自增ID" name="userId">
        <a-input
          allow-clear
          placeholder="请输入自增ID"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="姓名" name="realName">
        <a-input
          allow-clear
          placeholder="请输入姓名"
          v-model:value="form.realName"
        />
      </a-form-item>
      <a-form-item label="手机号" name="mobile">
        <a-input
          allow-clear
          placeholder="请输入手机号"
          v-model:value="form.mobile"
        />
      </a-form-item>
      <a-form-item label="支付密码" name="payPassword">
        <a-input
          allow-clear
          placeholder="请输入支付密码"
          v-model:value="form.payPassword"
        />
      </a-form-item>
      <a-form-item label="当前可提现佣金" name="money">
        <a-input
          allow-clear
          placeholder="请输入当前可提现佣金"
          v-model:value="form.money"
        />
      </a-form-item>
      <a-form-item label="已冻结佣金" name="freezeMoney">
        <a-input
          allow-clear
          placeholder="请输入已冻结佣金"
          v-model:value="form.freezeMoney"
        />
      </a-form-item>
      <a-form-item label="累积提现佣金" name="totalMoney">
        <a-input
          allow-clear
          placeholder="请输入累积提现佣金"
          v-model:value="form.totalMoney"
        />
      </a-form-item>
      <a-form-item label="推荐人用户ID" name="refereeId">
        <a-input
          allow-clear
          placeholder="请输入推荐人用户ID"
          v-model:value="form.refereeId"
        />
      </a-form-item>
      <a-form-item label="成员数量(一级)" name="firstNum">
        <a-input
          allow-clear
          placeholder="请输入成员数量(一级)"
          v-model:value="form.firstNum"
        />
      </a-form-item>
      <a-form-item label="成员数量(二级)" name="secondNum">
        <a-input
          allow-clear
          placeholder="请输入成员数量(二级)"
          v-model:value="form.secondNum"
        />
      </a-form-item>
      <a-form-item label="成员数量(三级)" name="thirdNum">
        <a-input
          allow-clear
          placeholder="请输入成员数量(三级)"
          v-model:value="form.thirdNum"
        />
      </a-form-item>
      <a-form-item label="专属二维码" name="qrcode">
        <a-input
          allow-clear
          placeholder="请输入专属二维码"
          v-model:value="form.qrcode"
        />
      </a-form-item>
      <a-form-item label="是否删除" name="isDelete">
        <a-input
          allow-clear
          placeholder="请输入是否删除"
          v-model:value="form.isDelete"
        />
      </a-form-item>
      <a-form-item label="修改时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入修改时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addShopDealerUser, updateShopDealerUser } from '@/api/shop/shopDealerUser';
  import { ShopDealerUser } from '@/api/shop/shopDealerUser/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ShopDealerUser | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ShopDealerUser>({
    id: undefined,
    userId: undefined,
    realName: undefined,
    mobile: undefined,
    payPassword: undefined,
    money: undefined,
    freezeMoney: undefined,
    totalMoney: undefined,
    refereeId: undefined,
    firstNum: undefined,
    secondNum: undefined,
    thirdNum: undefined,
    qrcode: undefined,
    isDelete: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    shopDealerUserId: undefined,
    shopDealerUserName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    shopDealerUserName: [
      {
        required: true,
        type: 'string',
        message: '请填写分销商用户记录表名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateShopDealerUser : addShopDealerUser;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
